const { createCli, utils } = require('@hperchec/juisy')
const path = require('path')
const {
  rootDir,
  $style
} = utils
// Get package.json content
const packageJson = require(path.resolve(rootDir, './package.json'))

const getBanner = () => {
  let str = ''
  const title = $style.bold('CLI: ') + packageJson.name
  const length = title.length - 9 // removes characters generated by $style.bold from length
  str += $style.cyan('-'.repeat(length) + '\n')
  str += $style.cyan(title + '\n')
  str += $style.cyan('-'.repeat(length) + '\n')
  str += $style.italic('Made with') + ' ' + $style.red('❤') + '  ' + $style.italic('by ') + $style.bold('Hervé Perchec <contact@herve-perchec.com>') + '\n'
  return str
}

// CLI
module.exports = createCli(cli => cli
  .scriptName('./bin/cli')
  .usage(`${getBanner()}\nUsage: $0 <command> [<options>]`)
  .commandDir('cmds')
  .demandCommand(1, ('Command is missing. See help to learn more.').red)
)
